#!/bin/sh
# $Id: dar-backup.sh,v 1.2 2011/04/29 15:12:19 root Exp $
# Needs curl, dar and mutt
#
# Backup Job

KEEP_BACKUPS=4
DATE=`date -I`

if [ -e /etc/dar-backup/dar-backup.conf ]; then
 . /etc/dar-backup/dar-backup.conf
 if [ -e /etc/dar-backup/dar-exclude.conf ]; then
  . /etc/dar-backup/dar-exclude.conf
 fi
elif [ -e /etc/backup-full.conf ]; then
 . /etc/backup-full.conf
else
 echo "No config file found for $0" >2
 exit 1
fi

if [ "x$CURLFS"!="x" ]; then
  if ! ( df -P | awk '$1 ~ /curlftpfs/ { print $6 }' | grep $CURLFS > /dev/null ); then
    curlftpfs -o user=$FTPUSER:$FTPPASS $FTPSERVER $CURLFS || exit $?
  fi
fi

(
# Make sure FTPSERVER has a trailing / and starts with ftp://
if echo $FTPSERVER | egrep -q -v '^ftp://' > /dev/null ; then
  FTPSERVER="ftp://$FTPSERVER"
fi
if echo $FTPSERVER | egrep -q -v '/$' > /dev/null ; then
  FTPSERVER="$FTPSERVER/"
fi
# Make sure BACKUPDIR has no leading or trailing /
BACKUPDIR=`echo $BACKUPDIR | sed 's/^\///; s/\/$//'`

cd /$BACKUPDIR || exit 1
mkdir -p $DATE
cd /$BACKUPDIR/$DATE

find . -maxdepth 1 -name "$HOSTID-*" -mtime +1 | xargs -r rm
SLICE="-s 100M"
[ "$1" = "--no-slice" ] && SLICE=""
dar -c /$BACKUPDIR/$DATE/$HOSTID-$DATE \
    -R / $SLICE \
    $DAREXCLUDE \
    -y \
    -G /$BACKUPDIR/$DATE/$HOSTID-$DATE-catalog \
    -D \
    -aa \
    -Q

status=$?
echo "dar-exit-status: $status"
echo $status >/$BACKUPDIR/$DATE/status

sync


cd /$BACKUPDIR || exit 1
ls -d [2-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9] |
head -n -$KEEP_BACKUPS | 
while read d; do
  rm -rf "$d"
done
cp /etc/motd .

) 2>&1 | mutt -s "Backup $HOSTID $DATE" $BACKUPMAIL

